class DummyClass
  include MSP

  def pub(param); end

  protected

  def pro(param); end

  private

  def pri(param); end
end

describe MSP::Service do
  subject { DummyClass.new }
  describe '#method_missing' do
    it 'calls #pub public method' do
      expect_any_instance_of(DummyClass).to receive(:pub).with('arg')
      DummyClass.pub('arg')
    end

    it 'calls #pro protected method' do
      expect_any_instance_of(DummyClass).to receive(:pro).with('arg')
      DummyClass.pro('arg')
    end

    it 'calls #pri private method' do
      expect_any_instance_of(DummyClass).to receive(:pri).with('arg')
      DummyClass.pri('arg')
    end

    it 'does not call methods on existing objects' do
      expect(subject).not_to receive(:pub)
      expect(subject).not_to receive(:pro)
      expect(subject).not_to receive(:pri)

      DummyClass.pub('arg')
      DummyClass.pro('arg')
      DummyClass.pri('arg')
    end

    it 'raises NoMethodError' do
      expect { DummyClass.wtf }.to raise_error NoMethodError
    end

    it 'raises ArgumentError' do
      expect { DummyClass.pub }.to raise_error ArgumentError
    end
  end
end
