require 'singleton'

describe MSP do
  describe '.included' do
    describe 'class' do
      class DummyClass
        include MSP
      end

      class DummySingletonClass
        include Singleton
        include MSP
      end

      it 'includes MSP::Service' do
        expect(DummyClass).to be_a_kind_of(MSP::Service)
        expect(DummySingletonClass).not_to be_a_kind_of(MSP::Service)
      end

      it 'includes MSP::SingletonService' do
        expect(DummyClass).not_to be_a_kind_of(MSP::SingletonService)
        expect(DummySingletonClass).to be_a_kind_of(MSP::SingletonService)
      end
    end

    describe 'module' do
      module DummyModule
        include MSP
      end

      it 'does not include MSP::SingletonService' do
        expect(DummyModule).not_to be_a_kind_of(MSP::SingletonService)
      end

      it 'includes MSP::Service' do
        expect(DummyModule).to be_a_kind_of(MSP::Service)
      end
    end
  end
end
